Bug 451615 - (CVE-2008-2364) CVE-2008-2364 httpd: mod_proxy_http DoS via excessive interim responses from the origin server
CVE-2008-2364 httpd: mod_proxy_http DoS via excessive interim responses from ...
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
http://nvd.nist.gov/nvd.cfm?cvename=C...
impact=moderate,public=20080610,repor...
: Security
Depends On: 447311 447312 454423 468836 468837 468838 468839 468840 468841
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-16 03:43 EDT by Tomas Hoger
Modified: 2014-11-30 23:17 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
A flaw was found in the mod_proxy module. An attacker who has control of a web server to which requests are being proxied could cause a limited denial of service due to CPU consumption and stack exhaustion. (CVE-2008-2364)
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-05-08 13:28:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Tomas Hoger 2008-06-16 03:43:50 EDT
Common Vulnerabilities and Exposures assigned an identifier CVE-2008-2364 to the following vulnerability:

The ap_proxy_http_process_response function in mod_proxy_http.c in the
mod_proxy module in the Apache HTTP Server 2.0.63 and 2.2.8 does not limit the
number of forwarded interim responses, which allows remote HTTP servers to
cause a denial of service (memory consumption) via a large number of interim
responses.

Fixed upstream in: 2.2.9
  http://www.apache.org/dist/httpd/CHANGES_2.2.9

Upsteam patch in 2.2.x branch:
  http://svn.apache.org/viewvc?view=rev&revision=666154

Other references:
http://www.securityfocus.com/bid/29653
http://www.frsirt.com/english/advisories/2008/1798
http://secunia.com/advisories/30621
http://xforce.iss.net/xforce/xfdb/42987
Comment 3 Joe Orton 2008-06-24 04:54:16 EDT
There are two separate issues here:

1) a stack exhaustion and CPU consumption issue.  This affects all upstream
httpd 2.0.x releases from through to 2.0.63, and 2.2.0 through to 2.2.8.   
Whilst reading interim responses, CPU consumption is O(N^2) with number of
responses read, and for each response the stack space required is O(N) likewise.
 This presents a denial of service attack either by CPU consumption or by the
eventual process crash due to stack limit being reached.

2) a heap exhaustion issue.  This affects upstream httpd releases 2.2.7 and
2.2.8 only. This presents a denial of service by heap exhaustion.

Red Hat Enterprise Linux 2 is not affected by either of these issues.

Red Hat Enterprise Linux 3, 4, and 5 are affected by issue (1) only.

Fedora 8 and 9 are affected by both (1) and (2) as of the most recent 2.2.8 updates.
Comment 4 Joe Orton 2008-06-24 05:56:08 EDT
Note that both these issues only affect a forward proxy configuration; where a
user can be coerced into accessing a malicious origin server through the proxy,
that server attack the proxy as described above.
Comment 5 Tomas Hoger 2008-06-24 11:04:34 EDT
We do not plan to issue an asynchronous RHSA at the moment because of this
issue, due to a limited impact.  This issue can cause high CPU consumption, or
stack overflow (exhaustion of stack memory, not stack-based buffer overflow)
causing a crash of httpd child process.  With default MPM - worker MPM - such
crash can only impact requests of one particular user.

Additionally, as the issue can only be triggered by a malicious web server to
which requests are proxied, impact on the typical use of mod_proxy module is
quite minimal.  mod_proxy is usually used in reverse proxy setups, where
requests are proxied to trusted (internal) web servers.  Forward proxy setups,
where requests can be proxied to arbitrary web server, are not very common, due
to a lack of caching support.  Squid web proxy is more commonly used in such cases.

We plan to fix this issue in some future httpd update once there is some
higher-severity issue to be fixed.
Comment 10 Fedora Update System 2008-08-07 19:48:01 EDT
httpd-2.2.9-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2008-08-07 19:57:13 EDT
httpd-2.2.9-1.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Mark J. Cox (Product Security) 2008-10-28 07:13:09 EDT
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
A flaw was found in the mod_proxy module.  An attacker who has control of a web server to which requests are being proxied could cause a limited denial of service due to CPU consumption and stack exhaustion.  (CVE-2008-2364)
Comment 15 errata-xmlrpc 2010-08-04 17:31:34 EDT
This issue has been addressed in following products:

  Red Hat Certificate System 7.3

Via RHSA-2010:0602 https://rhn.redhat.com/errata/RHSA-2010-0602.html
Comment 16 Vincent Danen 2013-05-08 13:28:05 EDT
This issue has been addressed in Red Hat Enterprise Linux 3, 4 and 5.  For more information see:

https://access.redhat.com/security/cve/CVE-2008-2364

Note You need to log in before you can comment on or make changes to this bug.